//uniform vec2 viewPort2;			// viewPort dimensions
uniform vec4 viewFrustum;		// x: view angle (radians); y: ratio (y / x); z: zNear; w: zFar

varying vec3 cameraRay;
varying vec2 invNearPlane;


void main() {

	gl_Position = ftransform();
	gl_TexCoord[0] = gl_MultiTexCoord0;
		
	// half view angle
	vec2 nearPlane = vec2(viewFrustum.x * 0.5);
	// y has a different angle
	nearPlane.y *= viewFrustum.y;
	// calculate the dimensions of the near plane
	nearPlane = tan(nearPlane) * 2.0;
	invNearPlane = 1.0 / nearPlane;
	
	// Shift the tex coord from [0, 1] to [-0.5, 0.5]..
	vec2 texCoord = gl_MultiTexCoord0.xy - 0.5;
	
	// ...And then to [-nearPlane, nearPlane]
	// Composed from 2D position on near plane and near plane depth
	cameraRay = vec3(texCoord * nearPlane, viewFrustum.z);
}
